# -*- coding: utf-8 -*-
from setuphelpers import *
from waptcrypto import SSLCertificate
import time
from datetime import *
import ctypes
import sys
import platform

def install():
    pass


#Uncomment session_setup() block if you want to display popups at session logon


##def session_setup():
##
##    #If needed, change the certificate directory to monitor:
##    cert_dir = glob.glob(makepath(user_local_appdata, 'private', '*.crt'))
##
##    for cert in cert_dir:
##        date_diff = SSLCertificate(cert).not_after - datetime.utcnow()
##        if date_diff <= timedelta(days=0):
##            message_box('WAPT Administrators Certificate Expiration ',f'certifictate {SSLCertificate(cert).cn} has expired')
##        elif date_diff < timedelta(days=15):
##            message_box('WAPT Administrators Certificate Expiration ',f'certificate {SSLCertificate(cert).cn} will expire soon')
##    return "RERUN"

def audit():

    expired_cert_list = []
    soon_expired_cert_list = []
    cert_dir = glob.glob(r'C:\Users\*\Appdata\Local\private\*.crt')
    for cert in cert_dir:
        date_diff = SSLCertificate(cert).not_after - datetime.utcnow()
        if date_diff <= timedelta(days=0):
            expired_cert_list.append(cert)
        if date_diff < timedelta(days=15):
            soon_expired_cert_list.append(cert)

    for cert in expired_cert_list:
            print(f'{cert} has expired')
    for cert in soon_expired_cert_list:
            print(f'{cert} will expire soon')

    if len(expired_cert_list) > 0:
        return "ERROR"
    elif len(soon_expired_cert_list) > 0:
        return "WARNING"
    else:
        return "OK"


def message_box(title, text, style=0):
    if platform.python_version_tuple()[0] == "3":
        import importlib

        importlib.reload(sys)
    else:
        reload(sys)
        sys.setdefaultencoding("utf-8")

    MB_OK = 0
    MB_OKCANCEL = 1
    MB_YESNOCANCEL = 3
    MB_YESNO = 4
    ctypes.windll.user32.MessageBoxW(0, "%s" % text, "%s" % title, style)
    return





